
/*  A Bison parser, made from oplpars.y  */

#define	INTEGER	258
#define	HEXINT	259
#define	CHARACTER	260
#define	IDENTIFIER	261
#define	SUBROUTINE	262
#define	STRING	263
#define	OPL_FUNCTION	264
#define	OPL_PROCEDURE	265
#define	OPL_PROCEDURE_NO_ARGS	266
#define	OPL_PRINT_PROC	267
#define	APP	268
#define	AND	269
#define	DO	270
#define	ELSE	271
#define	ELSEIF	272
#define	ENDA	273
#define	ENDP	274
#define	ENDIF	275
#define	ENDWH	276
#define	GLOBAL	277
#define	IF	278
#define	LOCAL	279
#define	OR	280
#define	PROC	281
#define	RETURN	282
#define	UNTIL	283
#define	WHILE	284
#define	LE	285
#define	GE	286
#define	NE	287
#define	POWER	288

#line 3 "oplpars.y"
                       /* C declarations */
#include "opldefs.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifndef __GNUC__
#define alloca malloc
#endif

#if defined(WIN32) || defined(__GNUC__)
#define xmalloc malloc
#endif

#define YYDEBUG 1
#define YYERROR_VERBOSE 1
extern int yylex( void );
void yyerror( char* s );
extern int _lineNo;

FILE *in;

#line 28 "oplpars.y"
typedef union
{
  char           *string;
  int             integer;
  ident          *id;
  identList      *idlist;
  procedure      *proc;
  procedureList  *plist;
  statement      *stmt;
  statementList  *slist;
  expression     *expr;
  expressionList *elist;
  program        *prog;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	YYFINAL		144
#define	YYFLAG		-32768
#define	YYNTBASE	46

#define YYTRANSLATE(x) ((unsigned)(x) <= 288 ? yytranslate[x] : 70)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    34,
    35,    44,    42,    36,    43,     2,    45,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    37,    39,    40,
    38,    41,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    81,    86,    88,    95,    98,   102,   107,   110,   118,   121,
   125,   133,   136,   140,   143,   145,   149,   152,   154,   158,
   161,   163,   165,   170,   172,   174,   176,   178,   180,   182,
   184,   186,   188,   196,   199,   203,   208,   211,   215,   218,
   222,   225,   227,   231,   235,   237,   241,   243,   247,   249,
   251,   255,   257,   259,   261,   263,   267,   269,   271,   275,
   277,   279,   281,   285,   288,   292,   295,   297,   299,   304,
   306,   308,   310,   312,   314,   316
};

static const char * const yytname[] = {     0,
"error","$illegal.","INTEGER","HEXINT","CHARACTER","IDENTIFIER","SUBROUTINE","STRING","OPL_FUNCTION","OPL_PROCEDURE",
"OPL_PROCEDURE_NO_ARGS","OPL_PRINT_PROC","APP","AND","DO","ELSE","ELSEIF","ENDA","ENDP","ENDIF",
"ENDWH","GLOBAL","IF","LOCAL","OR","PROC","RETURN","UNTIL","WHILE","LE",
"GE","NE","POWER","'('","')'","','","':'","'='","';'","'<'",
"'>'","'+'","'-'","'*'","'/'","program"
};
#endif

static const short yyr1[] = {     0,
    46,    47,    47,    48,    48,    49,    50,    50,    51,    51,
    52,    53,    53,    54,    54,    54,    55,    55,    55,    56,
    56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
    56,    56,    56,    57,    57,    58,    59,    59,    60,    60,
    61,    61,    61,    61,    62,    62,    63,    63,    64,    64,
    64,    65,    65,    65,    65,    65,    66,    66,    66,    67,
    67,    67,    67,    68,    68,    69,    69,    69,    69,    69,
    69,    69,    69,    69,    69,    69
};

static const short yyr2[] = {     0,
     3,     0,     2,     0,     2,     5,     0,     4,     0,     3,
     2,     0,     3,     0,     2,     2,     1,     3,     4,     4,
     4,     4,     6,     3,     3,     3,     2,     1,     2,     1,
     2,     4,     1,     0,     1,     2,     0,     3,     0,     2,
     0,     3,     3,     1,     1,     3,     1,     3,     1,     3,
     3,     1,     3,     3,     3,     3,     1,     3,     3,     1,
     3,     3,     3,     1,     2,     1,     1,     1,     4,     1,
     1,     4,     1,     4,     1,     3
};

static const short yydefact[] = {     2,
     0,     0,     3,     0,     4,     7,     1,     4,     0,    14,
     5,    12,     9,     0,    33,     0,    28,    39,    14,     0,
     0,     0,    30,     0,    14,     0,    14,     0,    11,     0,
     0,    34,     0,     0,    66,    67,    68,    70,    75,    71,
    73,     0,     0,    29,    37,    45,    47,    49,    52,    57,
    60,    64,    27,    41,     0,     9,    14,     9,    31,    14,
    15,     6,    16,     0,     9,     8,     0,    35,    24,     0,
    34,     0,     0,     0,    65,     0,     0,    36,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    44,    40,     0,    25,     0,    26,     0,    13,    10,
     0,    32,     0,     0,     0,    76,    46,    37,    48,    51,
    50,    55,    56,    53,    54,    58,    59,    63,    61,    62,
    41,    41,    22,    14,     0,    17,    20,    21,     0,    69,
    74,    72,    38,    42,    43,     0,    14,    23,    18,     0,
    19,     0,     0,     0
};

static const short yydefgoto[] = {   142,
     2,     7,     8,    10,    31,    13,    29,    26,   127,    27,
    67,    68,    78,    53,    93,    45,    46,    47,    48,    49,
    50,    51,    52
};

static const short yypact[] = {    -2,
     2,    -1,-32768,    22,    -1,    17,-32768,    -1,    49,    75,
-32768,    24,    36,   -16,    28,    27,-32768,    27,    75,    49,
    27,    49,    27,    27,    75,    74,    75,    27,-32768,    49,
    56,    27,    27,    27,-32768,-32768,-32768,    69,    76,-32768,
    79,    27,   116,-32768,     3,    83,     5,    43,    25,   -32,
-32768,-32768,-32768,   -12,    81,    36,    42,    36,   100,    42,
-32768,-32768,-32768,    82,    36,-32768,    91,-32768,   100,    92,
    27,    27,    27,    -9,-32768,    27,    27,-32768,    27,    27,
    27,    27,    27,    27,    27,    27,    27,    27,    27,    27,
    27,    27,-32768,    27,-32768,    72,-32768,    95,-32768,-32768,
    90,-32768,    94,    96,    97,-32768,    83,     3,     5,    43,
    43,    25,    25,    25,    25,   -32,   -32,-32768,-32768,-32768,
   -12,   -12,   100,    75,    27,-32768,-32768,-32768,    27,-32768,
-32768,-32768,-32768,-32768,-32768,   110,    42,   100,-32768,    72,
-32768,   133,   134,-32768
};

static const short yypgoto[] = {-32768,
-32768,   127,   135,-32768,   -42,    20,-32768,   -19,    -4,-32768,
    67,   -13,    31,-32768,   -46,   -14,    64,    62,    26,   -38,
    14,     6,    99
};


#define	YYLAST		150


static const short yytable[] = {    55,
    88,    76,    44,    54,    76,    61,    57,    63,    59,    60,
     1,    89,    90,    95,    64,    97,    76,    32,    69,     3,
    70,    33,   100,    91,     4,   106,    92,    74,     6,    35,
    36,    37,    38,    39,    40,    41,    80,    96,    77,    56,
    98,    58,    81,   112,   113,   114,   115,    14,    15,    65,
     9,    16,    17,    18,    12,    76,    19,    28,   104,   105,
    42,    34,   108,    20,    21,    22,    86,    87,    23,    43,
    24,    30,    82,    83,   134,   135,   121,   122,    25,   123,
    14,    15,    84,    85,    16,    17,    18,   124,   125,    19,
    66,   126,    62,   118,   119,   120,    20,    21,    22,   116,
   117,    23,    71,    24,   136,   110,   111,    79,    94,    72,
   137,    25,    73,    76,   138,   128,    99,   140,    35,    36,
    37,    38,    39,    40,    41,   101,   102,   129,   130,   139,
   131,   132,   143,   144,    11,   141,     5,   103,   133,   107,
   109,    75,     0,     0,     0,     0,     0,     0,     0,    42
};

static const short yycheck[] = {    19,
    33,    14,    16,    18,    14,    25,    21,    27,    23,    24,
    13,    44,    45,    56,    28,    58,    14,    34,    33,    18,
    34,    38,    65,    36,    26,    35,    39,    42,     7,     3,
     4,     5,     6,     7,     8,     9,    32,    57,    36,    20,
    60,    22,    38,    82,    83,    84,    85,     6,     7,    30,
    34,    10,    11,    12,     6,    14,    15,    34,    72,    73,
    34,    34,    77,    22,    23,    24,    42,    43,    27,    43,
    29,    36,    30,    31,   121,   122,    91,    92,    37,    94,
     6,     7,    40,    41,    10,    11,    12,    16,    17,    15,
    35,    20,    19,    88,    89,    90,    22,    23,    24,    86,
    87,    27,    34,    29,   124,    80,    81,    25,    28,    34,
   125,    37,    34,    14,   129,    21,    35,   137,     3,     4,
     5,     6,     7,     8,     9,    35,    35,    38,    35,    20,
    35,    35,     0,     0,     8,   140,     2,    71,   108,    76,
    79,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34
};
#define YYPURE 1

/* BISON template */
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "simple.bsn"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#include <alloca.h>
#else
#ifdef MSDOS
#include <malloc.h>
#else
void *alloca(unsigned);
#endif /* MSDOS */
#endif /* Sparc. */
#endif /* Not GNU C. */

#ifndef bcopy
#define bcopy(s,d,x) memcpy(d,s,x)
#endif

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYIMPURE
#define YYLEX		yylex()
#endif

#ifndef YYPURE
#define YYLEX		yylex(&yylval, &yylloc)
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYIMPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* YYIMPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#line 131 "simple.bsn"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/

#define YYPOPSTACK   (yyvsp--, yysp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yysp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifndef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Next token is %d (%s)\n", yychar, yytname[yychar1]);
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      if (yylen == 1)
	fprintf (stderr, "Reducing 1 value via rule %d (line %d), ",
		 yyn, yyrline[yyn]);
      else
	fprintf (stderr, "Reducing %d values via rule %d (line %d), ",
		 yylen, yyn, yyrline[yyn]);
    }
#endif


  switch (yyn) {

case 1:
#line 83 "oplpars.y"
{ prog.pProcs = new_procedureList( yyvsp[-1].proc, yyvsp[0].plist ); ;
    break;}
case 4:
#line 97 "oplpars.y"
{ yyval.plist = NULL; ;
    break;}
case 5:
#line 99 "oplpars.y"
{ yyval.plist = new_procedureList( yyvsp[-1].proc, yyvsp[0].plist ); ;
    break;}
case 6:
#line 104 "oplpars.y"
{ yyval.proc = new_procedure( yyvsp[-3].id, yyvsp[-2].idlist, yyvsp[-1].slist ); ;
    break;}
case 7:
#line 109 "oplpars.y"
{ yyval.idlist = NULL; ;
    break;}
case 8:
#line 111 "oplpars.y"
{ yyval.idlist = new_identList( yyvsp[-2].id, yyvsp[-1].idlist ); ;
    break;}
case 9:
#line 120 "oplpars.y"
{ yyval.idlist = NULL; ;
    break;}
case 10:
#line 122 "oplpars.y"
{ yyval.idlist = new_identList( yyvsp[-1].id, yyvsp[0].idlist ); ;
    break;}
case 11:
#line 127 "oplpars.y"
{
        yyvsp[-1].id->pArrays = yyvsp[0].elist;
        yyval.id = yyvsp[-1].id;
      ;
    break;}
case 12:
#line 135 "oplpars.y"
{ yyval.elist = NULL; ;
    break;}
case 13:
#line 137 "oplpars.y"
{ yyval.elist = yyvsp[-1].elist; ;
    break;}
case 14:
#line 142 "oplpars.y"
{ yyval.slist = NULL; ;
    break;}
case 15:
#line 144 "oplpars.y"
{ yyval.slist = yyvsp[0].slist; ;
    break;}
case 16:
#line 146 "oplpars.y"
{ yyval.slist = new_statementList( yyvsp[-1].stmt, yyvsp[0].slist ); ;
    break;}
case 17:
#line 151 "oplpars.y"
{ yyval.slist = NULL; ;
    break;}
case 18:
#line 153 "oplpars.y"
{ yyval.slist = yyvsp[-1].slist; ;
    break;}
case 19:
#line 155 "oplpars.y"
{ yyval.slist = new_statementList( new_if_statement( yyvsp[-2].expr, yyvsp[-1].slist, yyvsp[0].slist ), NULL ); ;
    break;}
case 20:
#line 160 "oplpars.y"
{ yyval.stmt = new_if_statement( yyvsp[-2].expr, yyvsp[-1].slist, yyvsp[0].slist ); ;
    break;}
case 21:
#line 162 "oplpars.y"
{ yyval.stmt = new_while_statement( yyvsp[-2].expr, yyvsp[-1].slist ); ;
    break;}
case 22:
#line 164 "oplpars.y"
{ yyval.stmt = new_do_statement( yyvsp[0].expr, yyvsp[-2].slist ); ;
    break;}
case 23:
#line 166 "oplpars.y"
{
        yyvsp[-5].id->pArrays = yyvsp[-3].elist;
        yyval.stmt = new_assignment_statement( yyvsp[-5].id, yyvsp[0].expr );
      ;
    break;}
case 24:
#line 171 "oplpars.y"
{ yyval.stmt = new_assignment_statement( yyvsp[-2].id, yyvsp[0].expr ); ;
    break;}
case 25:
#line 173 "oplpars.y"
{ yyval.stmt = new_global_statement( new_identList( yyvsp[-1].id, yyvsp[0].idlist ) ); ;
    break;}
case 26:
#line 175 "oplpars.y"
{ yyval.stmt = new_local_statement( new_identList( yyvsp[-1].id, yyvsp[0].idlist ) ); ;
    break;}
case 27:
#line 177 "oplpars.y"
{ yyval.stmt = new_call_statement( new_ident( yyvsp[-1].string, untyped_id, NULL ), yyvsp[0].elist, 1 ); ;
    break;}
case 28:
#line 179 "oplpars.y"
{ yyval.stmt = new_call_statement( new_ident( yyvsp[0].string, untyped_id, NULL ), NULL, 1 ); ;
    break;}
case 29:
#line 181 "oplpars.y"
{ yyval.stmt = new_call_statement( new_ident( yyvsp[-1].string, untyped_id, NULL ), yyvsp[0].elist, 1 ); ;
    break;}
case 30:
#line 183 "oplpars.y"
{ yyval.stmt = new_return_statement( NULL ); ;
    break;}
case 31:
#line 185 "oplpars.y"
{ yyval.stmt = new_return_statement( yyvsp[0].expr ); ;
    break;}
case 32:
#line 187 "oplpars.y"
{ yyval.stmt = new_call_statement( yyvsp[-3].id, yyvsp[-1].elist, 0 ); ;
    break;}
case 33:
#line 189 "oplpars.y"
{ yyval.stmt = new_call_statement( yyvsp[0].id, NULL, 0 ); ;
    break;}
case 34:
#line 198 "oplpars.y"
{ yyval.elist = NULL; ;
    break;}
case 35:
#line 200 "oplpars.y"
{ yyval.elist = yyvsp[0].elist; ;
    break;}
case 36:
#line 205 "oplpars.y"
{ yyval.elist = new_expressionList( yyvsp[-1].expr, yyvsp[0].elist ); ;
    break;}
case 37:
#line 210 "oplpars.y"
{ yyval.elist = NULL; ;
    break;}
case 38:
#line 212 "oplpars.y"
{ yyval.elist = new_expressionList( yyvsp[-1].expr, yyvsp[0].elist ); ;
    break;}
case 39:
#line 217 "oplpars.y"
{ yyval.elist = NULL; ;
    break;}
case 40:
#line 219 "oplpars.y"
{ yyval.elist = new_expressionList( yyvsp[-1].expr, yyvsp[0].elist ); ;
    break;}
case 41:
#line 224 "oplpars.y"
{ yyval.elist = NULL; ;
    break;}
case 42:
#line 226 "oplpars.y"
{ yyval.elist = new_expressionList( yyvsp[-1].expr, yyvsp[0].elist ); ;
    break;}
case 43:
#line 228 "oplpars.y"
{ yyval.elist = new_expressionList( yyvsp[-1].expr, yyvsp[0].elist ); ;
    break;}
case 44:
#line 232 "oplpars.y"
{ yyval.elist = NULL; ;
    break;}
case 46:
#line 238 "oplpars.y"
{ yyval.expr = new_binary_op_expression( and_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 48:
#line 244 "oplpars.y"
{ yyval.expr = new_binary_op_expression( or_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 50:
#line 250 "oplpars.y"
{ yyval.expr = new_binary_op_expression( equality_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 51:
#line 252 "oplpars.y"
{ yyval.expr = new_binary_op_expression( inequality_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 53:
#line 258 "oplpars.y"
{ yyval.expr = new_binary_op_expression( lessthan_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 54:
#line 260 "oplpars.y"
{ yyval.expr = new_binary_op_expression( greaterthan_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 55:
#line 262 "oplpars.y"
{ yyval.expr = new_binary_op_expression( lessequal_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 56:
#line 264 "oplpars.y"
{ yyval.expr = new_binary_op_expression( greaterequal_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 58:
#line 270 "oplpars.y"
{ yyval.expr = new_binary_op_expression( addition_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 59:
#line 272 "oplpars.y"
{ yyval.expr = new_binary_op_expression( subtraction_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 61:
#line 278 "oplpars.y"
{ yyval.expr = new_binary_op_expression( multiplication_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 62:
#line 280 "oplpars.y"
{ yyval.expr = new_binary_op_expression( division_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 63:
#line 282 "oplpars.y"
{ yyval.expr = new_binary_op_expression( power_expr, yyvsp[-2].expr, yyvsp[0].expr ); ;
    break;}
case 64:
#line 287 "oplpars.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 65:
#line 289 "oplpars.y"
{ yyval.expr = new_unary_op_expression( uminus_expr, yyvsp[0].expr ); ;
    break;}
case 66:
#line 294 "oplpars.y"
{ yyval.expr = new_integer_expr( integer_expr, yyvsp[0].integer ); ;
    break;}
case 67:
#line 296 "oplpars.y"
{ yyval.expr = new_integer_expr( hexint_expr, yyvsp[0].integer ); ;
    break;}
case 68:
#line 298 "oplpars.y"
{ yyval.expr = new_integer_expr( character_expr, yyvsp[0].integer ); ;
    break;}
case 69:
#line 300 "oplpars.y"
{
        yyvsp[-3].id->pArrays = yyvsp[-1].elist;
        yyval.expr = new_variable_expr( yyvsp[-3].id );
      ;
    break;}
case 70:
#line 305 "oplpars.y"
{ yyval.expr = new_variable_expr( yyvsp[0].id ); ;
    break;}
case 71:
#line 307 "oplpars.y"
{ yyval.expr = new_string_expr( yyvsp[0].string ); ;
    break;}
case 72:
#line 309 "oplpars.y"
{ yyval.expr = new_call_expression( yyvsp[-3].id, yyvsp[-1].elist, 1 ); ;
    break;}
case 73:
#line 311 "oplpars.y"
{ yyval.expr = new_call_expression( yyvsp[0].id, NULL, 1 ); ;
    break;}
case 74:
#line 313 "oplpars.y"
{ yyval.expr = new_call_expression( yyvsp[-3].id, yyvsp[-1].elist, 0 ); ;
    break;}
case 75:
#line 315 "oplpars.y"
{ yyval.expr = new_call_expression( yyvsp[0].id, NULL, 0 ); ;
    break;}
case 76:
#line 317 "oplpars.y"
{ yyval.expr = new_unary_op_expression( parenthesis_expr, yyvsp[-1].expr ); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 362 "simple.bsn"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) xmalloc(size + 15);
	  strcpy(msg, "parse error");

	  if (count < 5)
	    {
	      count = 0;
	      for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
		if (yycheck[x + yyn] == x)
		  {
		    strcat(msg, count == 0 ? ", expecting `" : " or `");
		    strcat(msg, yytname[x]);
		    strcat(msg, "'");
		    count++;
		  }
	    }
	  yyerror(msg);
	  free(msg);
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 320 "oplpars.y"

