typedef union
{
  char           *string;
  int             integer;
  ident          *id;
  identList      *idlist;
  procedure      *proc;
  procedureList  *plist;
  statement      *stmt;
  statementList  *slist;
  expression     *expr;
  expressionList *elist;
  program        *prog;
} YYSTYPE;

#define	INTEGER	258
#define	HEXINT	259
#define	CHARACTER	260
#define	IDENTIFIER	261
#define	SUBROUTINE	262
#define	STRING	263
#define	OPL_FUNCTION	264
#define	OPL_PROCEDURE	265
#define	OPL_PROCEDURE_NO_ARGS	266
#define	OPL_PRINT_PROC	267
#define	APP	268
#define	AND	269
#define	DO	270
#define	ELSE	271
#define	ELSEIF	272
#define	ENDA	273
#define	ENDP	274
#define	ENDIF	275
#define	ENDWH	276
#define	GLOBAL	277
#define	IF	278
#define	LOCAL	279
#define	OR	280
#define	PROC	281
#define	RETURN	282
#define	UNTIL	283
#define	WHILE	284
#define	LE	285
#define	GE	286
#define	NE	287
#define	POWER	288

extern YYSTYPE yylval;
